#include "pw/ui/window.hpp"

//#include "glad/glad.h"

pw::window::window() {

    _window = glfwCreateWindow(640, 480, "pixwerxs", NULL, NULL);

#if 0
    glfwMakeContextCurrent(_window);

    gladLoadGLLoader((GLADloadproc) glfwGetProcAddress);

#endif

}

pw::window::~window() {

    glfwDestroyWindow(_window);
}

bool pw::window::update()
{
    if (!glfwWindowShouldClose(_window)) {

        // do other stuff
#if 0
        glClearColor(1,0,0,1);
        glClear(GL_COLOR_BUFFER_BIT);
#endif

        glfwSwapBuffers(_window);
        glfwPollEvents();

        return true;
    }

    return false;
}

void pw::window::set_title(const char *t)
{
    glfwSetWindowTitle(_window,t);
}

void pw::window::set_size(int w,int h) {
    glfwSetWindowSize(_window,w,h);
}

void pw::window::load(sol::table &ns)
{
    glfwInit();

    ns.new_usertype<window>("window",
                            "update",&window::update,
                            "set_title",&window::set_title,
                            "set_size",&window::set_size
                            );
}

